import processing.serial.*;

/* Create object from Serial class */
Serial myPort; 

/*  tab selector variable  */
char tab = 'e';

/*  Various PImage objects used interchangeably throughout the GUI */
PImage img;
PImage mod;
PImage piano;

/* Default piano key = OFF */
char piano_key ='z';

// Variables
//0-lock 1-door 2? 3-music 4-disco 5,6,7 - security
boolean[] inputData = new boolean[8];  // create the input Data array to pass boolean values
int[][] stars = new int [3][20];

char[] slider ={ 0x30, 0x31, 0x32, 0x33, 0x34, 0x35};
int rangeCount = 1000;
boolean acknowledge = true;
boolean range = true;
int drag =0;
int star_pos = 290;
char input;
char [][] keys= {{'f','g','x','j','k','l','x','x'},
    {'c','v','b','n','m',',','.','/'}};
int [][] con = new int[keys.length][keys[0].length]; 


/******************************************************
 ******************************************************/

void setup() {
  size(650, 400);
  //println(Serial.list());
  String portName = "PORTNAMEHERE";
  myPort = new Serial(this, portName, 115200);
  int i;
  for (i = 0; i < 10; i++ ){
  stars[0][i] = (int)(255 * Math.random());
  } /* end for */
} /* end setup */


/******************************************************
 ******************************************************/

void draw() {
  background(255);
  int i, j;

  /*==================================================
  *                     LOAD TABS                    *
  ==================================================*/
  
  mod = loadImage("tabs.gif");
  imageMode(CORNER);
  tint(255,255,255,255);
  image(mod,10, 0);
  /*==========        END LOAD TABS       ==========*/
  


  /*==================================================
   *                    Piano module                  *
   *                                                  *
   *   This module displays an interactive piano      *
   *             which the user can play              *
   *==================================================*/
   
  if(tab == 'p'){
    mod = loadImage("piano module.gif");
    imageMode(CORNER);
    tint(255,255,255,255);
    image(mod,0, 100);

    for( i=0; i< keys.length; i++){
      for (j=0; j< keys[i].length; j++){
        
        if(keys[i][j] == piano_key && keys[i][j]!='x' && keys[i][j]!='/'){
          piano = loadImage("piano "+ piano_key +".gif");}
        if(piano_key=='/'){
          piano = loadImage("piano slash.gif");}
        if(piano_key=='z'){
          piano = loadImage("piano overlay.gif");}

        if((keys[i][j] == piano_key && keys[i][j]!='x') || piano_key == 'z'){
          imageMode(CORNER);
          tint(255,255,255,255);
          image(piano,34, 125);
        } /* end if */
        
      }//end if
    }//end for
  }//end for
    /*==========    END PIANO MODULE    ==========*/



  /*==================================================
   *                  Security module                 *
   *                                                  *
   *   This module displays home automation module    *
   * which is primarily responsible for micromanaging *
   *  home automation (4 input / displays, security   *
   *            and range indicators included         *
   *==================================================*/

  if (tab == 's') {
    /*  Home image loading  */
    mod = loadImage("home.gif");
    imageMode(CORNER);
    tint(255,255,255,255);
    image(mod,0, 100);


    /*  SUBCATEGORIES  */

    /*  Lock Procedure  */
    if(inputData[2] == false)
      img = loadImage("lock open.gif"); 
    else  // locked
      img = loadImage("Lock-icon.gif");

    imageMode(CORNER);
    tint(255,255,255,255);
    image(img,30, 370-img.height);
    /* end lock procedure */



    /* Door Openness Status Indicator */
    if(inputData[1] == true) //closed
      img = loadImage("stamp closed.gif");
    if(inputData[1] == false) //closed
      img = loadImage("stamp open.gif");

    imageMode(CORNER);
    tint(255,255,255,190);
    image(img,140, 370-img.height);
    /* end door openness status indicator */



    /*  Security Indicator  */
    if((inputData[1] == true) && (inputData[2] == true)) //secure
      img = loadImage("bolt check.gif");
    else   //not secure
      img = loadImage("bolt x.gif");

    imageMode(CORNER);
    tint(255,255,255,255);
    image(img,260, 110);     
    /* end security indicator */



    /*  Range Indicator  */
    if(range == true){
      img = loadImage("bolt check.gif");
    }
    if(range == false){ 
      if (inputData[2] == false){
        myPort.write(0x03);
        inputData[2] = true;
      } /* end if */
      img = loadImage("bolt x.gif");
    } /* end if */

    imageMode(CORNER);
    tint(255,255,255,255);
    image(img,500, 110); 
    /* end range indicator */



    /*  Stove Indicator  */
    if (inputData[5] == true) {
      img = loadImage("hammer on.gif");}
    else { 
      img = loadImage("hammer off.gif");
    } /* end if */

    imageMode(CENTER);
    tint(255,255,255,255);
    image(img,510, 200, 100,100); 
    /* end stove indicator */



    /*  AC Indicator  */
    // NEED TO EDIT: INPUTDATA[X], OPCODES
    if (inputData[6] == true) {
      img = loadImage("hammer on.gif");}
    else { 
      img = loadImage("hammer off.gif");
    } /* end if */

    imageMode(CENTER);
    tint(255,255,255,255);
    image(img,510, 275, 100,100); 
    /* end ac indicator */



    /*  Light Indicator  */
    // NEED TO EDIT: INPUTDATA[X], OPCODES
    if (inputData[7] == true) {
      img = loadImage("hammer on.gif");}
    else { 
      img = loadImage("hammer off.gif");
    } /* end if */

    imageMode(CENTER);
    tint(255,255,255,255);
    image(img,510, 350, 100,100); 
    /* end light indicator */

  } 
  /*========    END SECURITY MODULE    ========*/



  /*===================================================
   *             Entertaintment module                *
   *                                                  *
   *       *
   * which is primarily responsible for micromanaging *
   *  home automation (4 input / displays, security   *
   *            and range indicators included         *
   ===================================================*/

  if(tab == 'e'){
    mod = loadImage("entertainment.gif");
    imageMode(CORNER);
    tint(255,255,255,255);
    image(mod,0, 100);

    fill(255,0,0);
    rectMode(CORNERS);
    rect(280,142, star_pos, 154);
    img= loadImage("star.png");

    imageMode(CENTER);
    image(img, star_pos, 150);
    
    
    /*  Music Indicator  */
    // NEED TO EDIT: INPUTDATA[X], OPCODES
    if (inputData[3] == true) {
      img = loadImage("on.gif");
      myPort.write(0x0B);}
    else { 
      img = loadImage("off.gif");
      myPort.write(0x0C);
    } /* end if */

    imageMode(CENTER);
    tint(255,255,255,255);
    image(img,555, 280,170, 85); 
    /* end music indicator */


    /*  Disco Indicator  */
    if (inputData[4] == true) {
      img = loadImage("on.gif");
      myPort.write(0x0D);}
    else { 
      img = loadImage("off.gif");
      myPort.write(0x0E);
    } /* end if */

    imageMode(CENTER);
    tint(255,255,255,255);
    image(img,555, 345, 170,85); 
    /* end disco indicator */

    for(i = 0; i < 10; i++){
      if (stars[0][i] <= 0) {
        stars[0][i] = 255; /* intensity */
        stars[1][i] = 315 + (int)(Math.random()*300); /* x coordinate */
        stars[2][i] = 175 + (int)(Math.random()*60); /* y coordinate */       
      } /* end if */
      else
        stars[0][i] -= 2 +i%7;
      
      img = loadImage("star.png");
      tint(255,255,255,stars[0][i]);
      image(img, stars[1][i], stars[2][i], 20-i, 20-i);

    }//end for

    for( i=0; i< keys.length; i++){
      for (j=0; j< keys[i].length; j++){
        if(con[i][j] > 0 && keys[i][j]!='z'){
          img= loadImage("concentric circles.png");
          tint(255,255,255,con[i][j]);
          image(img,70-(i*20)+j*31,300+i*33,(int)(.6*(255-con[i][j])),(int)(.6*(255-con[i][j])));
          con[i][j]-=10;
        }//end if
      }//end for
    }//end for

  }//end if

  // Range: test if in range
  if(rangeCount >= 100){
    if (acknowledge == true){
      range = true; // in range
      acknowledge = false;
    }
    else 
      range = false; // out of range
    
    rangeCount = 0;
    myPort.write(0x21); // send out ask signal
}//end if

  rangeCount++; // update count signal
 
  //=================================================================================
  //                                Input opcode handler
  //=================================================================================
  while (myPort.available() > 0) {
    char inByte = myPort.readChar();

    //door signals  
    if(inByte == 0x01)  //locked
      inputData[2] = true;
    if(inByte == 0x02)  //unlocked
      inputData[2] = false;  
    if(inByte == 0x08)  //open
      inputData[1] = true; 
    if(inByte == 0x07)  //closed
      inputData[1]= false;

    // Acknowledge in range
    if(inByte == 0x22)
      acknowledge = true; 

  } /* end if */

} /* end main */


/******************************************************
 ******************************************************/

void mousePressed()
{
  if ((mouseY > 130 && mouseY < 160) && (mouseX > star_pos-20 && mouseX < star_pos + 20)) {
    drag = 1;
  } /* end if */
} /* end mousePressed */


/******************************************************
 ******************************************************/

void mouseDragged()
{
  if(drag ==1 && (mouseX > 290 && mouseX < 539)){
    star_pos = mouseX;
  }

} /* end mouseDragged */


/******************************************************
 ******************************************************/

void mouseReleased()
{
  drag = 0;
  if (tab == 'e') {
  int  slide_value = (int)((star_pos - 290)/42);
  myPort.write(slider[slide_value]);
  } /* end if */
} /* end mouseReleased */


/******************************************************
 ******************************************************/

void keyPressed()
{
  /*  iterator variables  */
  int i, j;

  /*  Set up piano option for the piano Module  */
  if (tab == 'p') {
    for (i = 0; i < keys.length; i++) {
      for (j = 0; j < keys[i].length; j++) {
        if ((keys[i][j] == key && key != 'x')) {
          piano_key = key;
          myPort.write(key);
        } /* end if */
      } /* end for */
    } /* end for */

    if (key == 'z') {
      piano_key = key;
      myPort.write(key);
    } /* end if */
  } /* end if */

  /*  Set up piano option for the entertaintment module  */
  if (tab == 'e') {
    for (i = 0; i < keys.length; i++) {
      for (j = 0; j < keys[i].length; j++) {
        if (keys[i][j] == key) {
          /*  Set up transparency to opaque for the pressed bit  */
          con[i][j]=255;
          myPort.write(key);
        } /* end if */
      } /* end for */
    } /* end for */

    if (key == 'z') {
      myPort.write(key);
    } /* end if */

  } /* end if */

} /* end keyPressed */


/******************************************************
 ******************************************************/

void mouseClicked()
{
  /*===================================================
   *                  TABS NAVIGATOR                  *
  ===================================================*/ 
  if (mouseY > 0 && mouseY < 100){
    if (mouseX > 290 && mouseX < 410) {
      tab = 's';
      myPort.write(0x00);
    } /* end if */

    if (mouseX > 410 && mouseX < 530) {
      tab = 'e';
      myPort.write(0x20);
    } /* end if */

    if (mouseX > 530 && mouseX < 650){
      tab = 'p';
      myPort.write(0x40);
    } /* end if */
  } /* end if */
  /*==========     END TABS NAVIGATOR   =============*/ 



  /*===================================================
   *            ENTERTAINTMENT NAVIGATOR              *
  ===================================================*/ 
  if (tab == 'e') {
    
       /*  MUSIC INDICATOR  */
    if (mouseX > 465 && mouseX < 645){
      /* AC button */
      if (mouseY > 280 - 40 && mouseY < 280 + 40){
        if (inputData[3] == true){
          inputData[3] = false;
          myPort.write(0x0C);
        }
        else{
          inputData[3] = true;
          myPort.write(0x0B);
        }
      } /* end MUSIC */

/*   DISCO INDICATOR  */
      if (mouseY > 345 - 40 && mouseY < 345 + 40){
        if (inputData[4] == true){
          inputData[4] = false;
          myPort.write(0x0E);
        }
        else{
          inputData[4] = true;
          myPort.write(0x0D);
        }
      } /* end STOVE */
      
    } /* end if */
  } /* end if */ 
  /*========   END ENTERTAINTMENT NAVIGATOR  ========*/ 



  /*===================================================
   *                 SECURITY MODULE                  *
  ===================================================*/ 
  if (tab == 's') {

    /*  Security Buttons - STOVE, AC, LIGHTS */
    if (mouseX > 510 - 40 && mouseX < 510 + 40){

      /* LIGHTS button */
      if (mouseY > 350 - 40 && mouseY < 350 + 40){
        if (inputData[7] == true) {
          myPort.write(0x0A);
          inputData[7] = false;
        } /* end if */
        else {
          myPort.write(0x09);
          inputData[7] = true;
        } /* end else */
      } /* end STOVE */

      /* AC button */
      if (mouseY > 275 - 40 && mouseY < 275 + 40){
        if (inputData[6] == true)
          inputData[6] = false;
        else
          inputData[6] = true;
      } /* end STOVE */

      /* STOVE button */
      if (mouseY > 200 - 40 && mouseY < 200 + 40){
        if (inputData[5] == true)
          inputData[5] = false;
        else
          inputData[5] = true;
      } /* end STOVE */
    } /* end stove, AC, lights buttons */


    /*  Lock Locker/Unlocker  */
    if ((mouseY > 311 && mouseY < 362) && (mouseX > 48 && mouseX < 115)) {
      if (inputData[2] == true) {
        myPort.write(0x04);
        inputData[2] = false;
      } /* end if */
      else {
        myPort.write(0x03);
        inputData[2] = true;
      } /* end else */
    } /* end if */
  } 
  /*==========     END SECURITY MODULE   =============*/ 


} /* end mouseClicked */
